#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/delay.h>
#include "main.h"



//SPI EINSCHALTEN
void osd_on(void)
{
osd_cs_high();
SPCR = (1<<SPE)|(1<<MSTR); //Enable SPI, SPI in Master Mode	
}

//SPI
void osd_off(void)
{
osd_cs_high();
SPCR = 0x00;    // SPI wieder disablen
}

void spiWriteReg(const unsigned char regAddr, const unsigned char regData)
{
osd_on();
osd_cs_low();
Write_SPI(regAddr);
Write_SPI(regData);
osd_cs_high();
osd_off();
}

void spiWriteRegInc( const unsigned char regData)
{
osd_on();
osd_cs_low();
Write_SPI(regData);
osd_cs_high();
osd_off();
}


//OFFSET Horizontal
void osd_offset_hor(const unsigned char offset)
{
spiWriteReg(0x02,offset);
}


//OFFSET VERTIKAL
void osd_offset_vert(const unsigned char offset)
{
spiWriteReg(0x03,offset);
}

//MEMORY HIGH ADRESS
void osd_mem_high(void)
{
spiWriteReg(0x05,0xff);


}


//MEMORY LOW ADRESS
void osd_mem_low(void)
{

spiWriteReg(0x05,0x00);

}

//OSD CLEAR
void clear_osd(void)
{
spiWriteReg(VIDEO_MODE_0_WRITE,0x42);
}

//SEND CHAR
void osd_draw_char(unsigned char position,unsigned char zeichen)
{
spiWriteReg(0x06,0x32);
spiWriteReg(0x07,0x02);

}

void osd_rest_chip(void)
{
spiWriteReg(0x00,0x02);
}


void OSD_write_to_screen(const char s[], unsigned char x, unsigned char y)
{
  unsigned int linepos;
   uchar char_address_hi, char_address_lo;
 

 

  char_address_hi = 0;
  char_address_lo = 0;

  // convert x,y to line position
  linepos = y*30+x;

  // divide in to hi & lo byte
  char_address_hi = linepos >> 8;
  char_address_lo = linepos;

 
  
  
  

 spiWriteReg(0x05,char_address_hi); // set start address high
 spiWriteReg(0x06,char_address_lo); // set start address low
x++;
spiWriteReg(0x07,0xfB);
linepos = y*30+x;
 // divide in to hi & lo byte
  char_address_hi = linepos >> 8;
  char_address_lo = linepos;
spiWriteReg(0x05,char_address_hi); // set start address high
 spiWriteReg(0x06,char_address_lo); // set start address low
 spiWriteReg(0x07,0x18);


  
    

   

 
  

  spiWriteReg(DMM_reg,0x00); //dmm
  


}









unsigned short int read_status_osd(void)
{
unsigned short int status;
osd_on();
osd_cs_low();
Write_SPI(0xa0);
status=Write_SPI(0xff);
osd_cs_high();
osd_off();
return status;
}